
#define CloudPlane

#ifdef CloudPlane

float wind = abs(frameTimeCounter - 0.5);
vec2 wind2 = abs(vec2(frameTimeCounter * 0.00005, 0.0));

varying float SdotU;
varying float MdotU;
varying float sunVisibility;
varying float moonVisibility;

float subSurfaceScattering1(vec3 vec,vec3 pos, float N) {

return pow(max(dot(vec,normalize(pos)),0.0),N)*(N+1)/6.28;

}
float subSurfaceScattering2(vec3 vec,vec3 pos, float N) {

return pow(max(dot(vec,normalize(pos))*0.5+0.5,0.0),N)*(N+1)/6.28;

}

vec3 drawCloud(vec3 fposition,vec3 color) {

vec3 sVector = normalize(fposition);
float cosT = max(dot(normalize(sVector),upVec),0.0);
float McosY = MdotU;
float cosY = SdotU;
vec3 tpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0));
vec3 wvec = normalize(tpos);
vec3 wVector = normalize(tpos);

vec4 totalcloud = vec4(.0);

vec3 intersection = wVector*((-cameraPosition.y+400.0+400*sqrt(cosT))/(wVector.y));
vec3 iSpos = (gbufferModelView*vec4(intersection,1.0)).rgb;
float cosT2 = max(dot(normalize(iSpos),upVec),0.0);


for (int i = 0;i<10;i++) {
	intersection = wVector*((-cameraPosition.y+200.0-i*3.*(1+cosT2*cosT2*3.5)+425*sqrt(cosT2))/(wVector.y)); 			//curved cloud plane
	vec3 wpos = tpos.xyz+cameraPosition;
	vec2 coord1 = (intersection.xz+cameraPosition.xz) / 1000.0 / 140.0 + wind * 0.00001;
	vec2 coord = fract(coord1/2.0);


	float noise = texture2D(noisetex,coord+frameTimeCounter/16000).x;
	noise += texture2D(noisetex,coord*3.5).x/3.5;
	noise += texture2D(noisetex,coord*12.25).x/12.25;
	noise += texture2D(noisetex,coord*42.87).x/42.87;
	noise /= 2;

	float cl = max(noise-0.4  +rainStrength*0.8,0.0)*(1-rainStrength*0.8);
	float density = max(1-cl*2.5,0.)*max(1-cl*2.5,0.)*(i/11.)*(i/11.);

	vec3 c =(ambientlight + mix(sunlight,length(sunlight)*vec3(0.25,0.32,0.4),rainStrength)*sunVisibility + mix(moonlight,length(moonlight)*vec3(0.25,0.32,0.4),rainStrength) * moonVisibility) * 0.12*1.6 *density + (24.*subSurfaceScattering1(sunVec,fragpos,10.0)*pow(density,3.) + 10.*subSurfaceScattering2(sunVec,fragpos,0.1)*pow(density,2.))*mix(sunlight,length(sunlight)*vec3(0.25,0.32,0.4),rainStrength)*sunVisibility +  (24.*subSurfaceScattering1(moonVec,fragpos,10.0)*pow(density,3.) + 10.*subSurfaceScattering2(moonVec,fragpos,0.1)*pow(density,2.))*mix(moonlight,length(moonlight)*vec3(0.25,0.32,0.4),rainStrength)*moonVisibility;
  	cl = max(cl-(abs(i-5.)/5.)*0.01,0.)*0.08;

	totalcloud += vec4(c.rgb*exp(-totalcloud.a),cl);

	vec3 ambientColor = vec3(106, 72, 48) * time[0].x;
		 ambientColor = mix(ambientColor, vec3(185, 185, 185), time[0].y);
		 ambientColor = mix(ambientColor, vec3(136, 72, 48), time[1].x);
		 ambientColor = mix(ambientColor, vec3(25, 25, 25), time[1].y);
		
	totalcloud.rgb *= ambientColor/255;

		if (totalcloud.a > 0.999) break;
	
	}

		return mix(color.rgb,totalcloud.rgb*(1 - rainStrength*0.87)*333,totalcloud.a*pow(cosT2,1.0));

	}


#endif