const vec2 celshadeoffset[8] = vec2[8](vec2(1.0,0.0),vec2(-1.0,0.0),vec2(0.0,1.0),vec2(0.0,-1.0),vec2(0.7,0.7),vec2(-0.7,0.7),vec2(0.7,-0.7),vec2(-0.7,-0.7));

float celshade(sampler2D depth, float forcefull){
	float pw = 1.0 * 0.0010416666666667;
	float ph = pw*aspectRatio;

	float outline = ld(texture2D(depth,texcoord.xy).r)*far*8.0;
	float minz = far;
	float sample = 0.0;

	for (int i = 0; i < 8; i++){
		sample = ld(texture2D(depth,texcoord.xy+vec2(pw,ph)*celshadeoffset[i]).r)*far;
		outline -= sample;
		minz = min(minz, sample);
	}
	
	float dist = 4096.0;

	outline = mix(clamp(1.0-outline*0.5,0.0,1.0),1.0,min(minz/dist,0.8+0.2*isEyeInWater)*(1.0-forcefull));

	return outline;
}

float celshademask(sampler2D depth0, sampler2D depth1){
	float pw = 1.0 * 0.0010416666666667;
	float ph = pw*aspectRatio;

	float mask = 0.0;
	for (int i = 0; i < 8; i++){
		mask += float(texture2D(depth0,texcoord.xy+vec2(pw,ph)*celshadeoffset[i]).r < texture2D(depth1,texcoord.xy+vec2(pw,ph)*celshadeoffset[i]).r);
	}

	return clamp(mask,0.0,1.0);
}